const _ = require("lodash")
const cheerio = require("cheerio");

const {
    embedCode,
    highlightCode,
    rewriteLinks,
    processImages,
    addSectionAnchors,
    addIdsForIndexableFragments,
    fixClosingTagsInHighlightedCode
} = require(`./src/utils`)

const {
    DEFAULT_OPTIONS,
    imageClass,
    imageBackgroundClass,
    imageWrapperClass
} = require(`./src/constants`)


//###########################################################################
//# get Html Sharp
//###########################################################################
const getHtmlPrismicBeta = async (value, actions, createNodeId, getNodesByType, pathPrefix, store,cache, options, reporter, variables) => {

    const { createNode } = actions

    if (!variables)
        variables = []

    // For correct highlighting of HTML code, we need to disable
    // entity resolution in cheerio and then patch this in the
    // serialized HTML, see fixClosingTagsInHighlightedCode() below.
    let $ = cheerio.load(value, { decodeEntities: false });
    $ = await processImages($, pathPrefix, createNode, getNodesByType, reporter, store, cache, variables, options);
    $ = rewriteLinks($);
    $ = addSectionAnchors($);
    //$ = embedCode($, node.dir, variables, reporter);
    $ = highlightCode($);
    $ = addIdsForIndexableFragments($);

    let html = fixClosingTagsInHighlightedCode($.html());
    //var ss = createMapReplacer(variables)
    // reporter.info( $(`body`).html() )
    //html = replaceVariables(html, createMapReplacer(variables));
    //console.log('NODE CONTENT ------ ', $(`body`).html())

    return await $(`body`).html();
}


exports.parseNodeContent = async ({
                                actions,
                                cache,
                                pathPrefix,
                                getNodesByType,
                                createNodeId,
                                createContentDigest,
                                loadNodeContent,
                                createResolvers,
                                store,
                                reporter,
                                variables
                            }, value, pluginOptions = {}) => {

    const { plugins = [] } = pluginOptions
    const options = _.defaults(pluginOptions, { pathPrefix }, DEFAULT_OPTIONS)

    //console.log('NODE ------ ', node.internal.type)
    //console.log('NODE TITLE ------ ', node.data.title)
    //console.log('NODE CONTENT ------ ', value)


    return await getHtmlPrismicBeta( value, actions, createNodeId, getNodesByType, pathPrefix, store, cache, options, reporter, variables )

    //return node
}